import _toConsumableArray from "@babel/runtime-corejs2/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs2/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs2/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime-corejs2/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs2/helpers/getPrototypeOf";
import _inherits from "@babel/runtime-corejs2/helpers/inherits";
import _assertThisInitialized from "@babel/runtime-corejs2/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime-corejs2/helpers/defineProperty";
import _taggedTemplateLiteral from "@babel/runtime-corejs2/helpers/taggedTemplateLiteral";

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  position: relative;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  width: 0;\n  height: 0;\n  opacity: 0.1;\n  position: absolute;\n  z-index: -1;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  justify-content: space-around;\n  align-items: center;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  width: 35px;\n  height: 35px;\n  box-sizing: border-box;\n  border: 1px solid #000;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  @keyframes flash {\n    from,\n    50%,\n    to {\n      opacity: 1;\n    }\n    25%,\n    75% {\n      opacity: 0;\n    }\n  }\n  &::before {\n    content: '';\n    display: ", ";\n    height: 15px;\n    width: 1px;\n    background: rgb(0, 0, 0);\n    margin-left: 2px;\n    animation: flash 2s infinite both;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

import React, { Component } from 'react';
import styled from 'styled-components';
var BlockEl = styled.span(_templateObject(), function (props) {
  return props.current ? 'block' : 'none';
});
var BlockElWrap = styled.div(_templateObject2());
var Input = styled.input(_templateObject3());
var BlockInputWrap = styled.div(_templateObject4());

var BlockInput =
/*#__PURE__*/
function (_Component) {
  _inherits(BlockInput, _Component);

  function BlockInput(props) {
    var _this;

    _classCallCheck(this, BlockInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BlockInput).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "input", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "defaultValues", void 0);

    var _props$length = props.length,
        length = _props$length === void 0 ? 6 : _props$length,
        _props$placeholder = props.placeholder,
        placeholder = _props$placeholder === void 0 ? '' : _props$placeholder;
    _this.defaultValues = Array(length).fill(placeholder);
    _this.state = {
      values: _this.defaultValues,
      input: '',
      curIndex: 0,
      focused: false,
      length: length
    };
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.inputFocus = _this.inputFocus.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onBlur = _this.onBlur.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(BlockInput, [{
    key: "onChange",
    value: function onChange(e) {
      var length = this.state.length;
      var _this$props = this.props,
          mask = _this$props.mask,
          onChange = _this$props.onChange;
      var input = e.target.value;
      var values = input.split('');

      if (values.length > length) {
        return;
      }

      var newStateValues = values.reduce(function (old, cur, index) {
        old[index] = mask || cur;
        return old;
      }, _toConsumableArray(this.defaultValues));
      this.setState({
        input: input,
        curIndex: values.length,
        values: newStateValues
      }, function () {
        if (onChange) {
          onChange(input);
        }
      });
    }
  }, {
    key: "inputFocus",
    value: function inputFocus() {
      var _this2 = this;

      this.input.focus();
      this.setState({
        focused: true
      }, function () {
        var onFocus = _this2.props.onFocus;

        if (onFocus) {
          onFocus();
        }
      });
    }
  }, {
    key: "onBlur",
    value: function onBlur() {
      var _this3 = this;

      this.setState({
        focused: false
      }, function () {
        var onBlur = _this3.props.onBlur;

        if (onBlur) {
          onBlur();
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state = this.state,
          values = _this$state.values,
          input = _this$state.input,
          curIndex = _this$state.curIndex,
          focused = _this$state.focused;
      var className = this.props.className;
      return React.createElement(BlockInputWrap, {
        className: className
      }, React.createElement(Input, {
        ref: function ref(el) {
          _this4.input = el;
        },
        value: input,
        type: "text",
        onChange: this.onChange,
        onBlur: this.onBlur
      }), React.createElement(BlockElWrap, {
        onClick: this.inputFocus
      }, values.map(function (v, k) {
        return React.createElement(BlockEl, {
          key: k,
          current: curIndex === k && focused
        }, v);
      })));
    }
  }]);

  return BlockInput;
}(Component);

export default BlockInput;