import { Component } from 'react';
interface IBlockState {
    values: string[];
    input: string;
    length: number;
    curIndex: number;
    focused: boolean;
}
interface IBlockProps {
    length?: number;
    mask?: string;
    className?: string;
    placeholder?: string;
    onChange?(v: string): void;
    onFocus?(): void;
    onBlur?(): void;
}
declare class BlockInput extends Component<IBlockProps> {
    state: IBlockState;
    input: HTMLInputElement;
    defaultValues: string[];
    constructor(props: any);
    onChange(e: any): void;
    inputFocus(): void;
    onBlur(): void;
    render(): JSX.Element;
}
export default BlockInput;
